*****************************************************************************
*
* Collapse effectively cuts the number of periods in a model in half.  Thus
*  the NYRSPER, STARTYRS and STARTS for the individual must be adjusted
*  appropriately.
*
*****************************************************************************
*GG* V1.2b

* establish the log file
FILE CLOG / CONVERT.LOG /;
PUT CLOG;
CLOG.NW=4;CLOG.ND=1;CLOG.PW=150;

IF (COLLAPSE NE 0,

  PUT CLOG ' ***** TRACE LOG - COLLAPSE OPERATIONS STARTUP ***** ' //;
  PUT CLOG ' NUMBER OF YEARS PER PERIOD FROM ' NYRSPER ' TO ' (NYRSPER*2) /;
  PUT CLOG ' STARTYRS ADJUSTED FROM ', STARTYRS ' TO '
               (STARTYRS + 0.5*((2*NYRSPER) - NYRSPER)) //;
  STARTYRS = STARTYRS + 0.5*((2*NYRSPER) - NYRSPER);
  NYRSPER = NYRSPER * 2;
PUT CLOG ' STARTS WILL BE ADJUSTED ORIGINAL = NEW: 1 = 1; 2/3 = 2; 4/5 = 3; ETC.' /;
  PUT CLOG ' NUMBER OF PERIODS IN LIFE WITH BE CUT IN HALF '  /;
  PUT CLOG ' ANY TID GROWTH RATES WILL BE DOUBLED '  //;

* adjust starting periods
  LOOP (SEP(SRC,ENT,P)$(SEP_START(SEP) GT 2),
* write to log for those resources where start is adjusted
    PUT CLOG ' START ADJUSTED FROM ' SEP_START(SEP) ' TO '
               (FLOOR(SEP_START(SEP)/2) + 1)
             ' FOR RESOURCE = ' SRC.TL:<3,ENT.TL:<3,P.TL:<1 /;
    SEP_START(SEP)=  FLOOR(SEP_START(SEP)/2) + 1;
  );
  LOOP (TCH$(TCH_START(TCH) GT 2),
* write to log for those technologies where start is adjusted
    PUT CLOG ' START ADJUSTED FROM ' TCH_START(TCH) ' TO '
             (FLOOR(TCH_START(TCH)/2) + 1) ' FOR TECHNOLOGY = ' TCH.TL /;
    TCH_START(TCH) = FLOOR(TCH_START(TCH)/2) + 1;
  );

);

* make 2 decimals points and allow for wider page
CLOG.NW=10;CLOG.ND=2;CLOG.PW=150;
