******************************************************************************
*                                                                            *
*  Piece Together the Various Parts of the Model(s) According to             *
*   - %1 = GMARKAL, MARKAL-MACRO or MARKAL-MICRO, the model being run        *
*   - %2 = START or RESTART, to being from scratch or start with previous    *
*          model declaration and results                                     *
*   - %3 = PRESOLVE or anything, if wishing to first solve MARKAL then       *
*                                MARKAL-MACRO or MARKAL-MICRO                *
*                                                                            *
****************************************************************************
SCALAR TAXES /0/;
SCALAR SUBS / 0/;
SCALAR SUBNEW / 0/;
$IF NOT ERRORFREE $ABORT '*** ERRORS IN INPUT DATA DICTIONARY ***'
$INCLUDE MMSETS.INC
$INCLUDE MMVARS.INC
$INCLUDE MMVARS.MM
$INCLUDE MMVARS.MI

$INCLUDE MMFILL.INC
$IF %1 == 'MARKAL-MACRO' $INCLUDE MMFILL.MM

$INCLUDE COLREST.INC
$INCLUDE FRACLIFE.INC
$INCLUDE DIFFCOST.INC

$INCLUDE MMCOEF.INC

$IF %1 == 'MARKAL-MACRO' $INCLUDE MMACRO.MM

$INCLUDE MMBNDS.INC
$IF %1 == 'MARKAL-MACRO' $INCLUDE MMBNDS.MM
$IF %1 == 'MARKAL-MICRO' $INCLUDE MMICRO.MI

$IF %2 == 'RESTART' $GOTO NOEQUA
*=============================================================================*
*  Give Complete Model Definition, NOT a RESTART                              *
*=============================================================================*
$INCLUDE MMEQUA.INC
$INCLUDE MMEQUA.MM
$INCLUDE MMEQUA.MI
$INCLUDE MODEL.MRK
$INCLUDE MODEL.MM
$INCLUDE MODEL.MI

$LABEL NOEQUA


$IF NOT ERRORFREE $ABORT '*** ERRORS IN COMPILATION ***'
ABORT$EXECERROR '*** ERRORS IN EXECUTION ***'

$ONLISTING
$IF %1 == 'GMARKAL' SOLVE MRK MAXIMIZING OBJZ USING LP;
$IF %3 == 'PRESOLVE' SOLVE MRK MAXIMIZING OBJZ USING LP;
$OFFLISTING
$IF %1 == 'GMARKAL' ABORT$((MRK.MODELSTAT GT 1) OR (MRK.SOLVESTAT GT 1)) '*** ERRORS IN LP OPTIMIZATION ***'
$IF %3 == 'PRESOLVE' ABORT$((MRK.MODELSTAT GT 1) OR (MRK.SOLVESTAT GT 1)) '*** ERRORS IN LP OPTIMIZATION ***'

SET RW(*) / T01,T02,T03,T04,T05,T06,T08,T09,T11,T25,T27,CAP,INV,SUPPLY,
            ACT, DEMAND, OUTTABS, COSTBEN/;
PARAMETER DECIMALS(RW,*)  / EMPTY.EMPTY 0 /;
SET UMULT(*) / M, E, YE, SH, SN /;
PARAMETER UNITS(UMULT,*)  / EMPTY.EMPTY 0 /;
$INCLUDE UNITS.INC
$INCLUDE DECIMALS.INC

SET RUNRPTS(RW) / EMPTY /;
$INCLUDE RUNRPT.INC


$IF %3 == 'PRESOLVE' $INCLUDE PRESET.MM

$IF %1 == 'GMARKAL' $GOTO NOTMM
SCALAR TRUE / 1 /, FALSE / 0 /;
SCALAR TRYAGAIN, SUCCESS / 1 /;
SET ATTEMPTS / 1*7 /;
MKMC.MODELSTAT = 0;
MKMC.SOLVESTAT = 0;
MKMI.MODELSTAT = 0;
MKMI.SOLVESTAT = 0;
$IF %1 == 'MARKAL-MICRO' $GOTO M-MI

OPTION SOLPRINT = ON;
PARAMETERS TDEM(TP) TOTAL DEMAND / EMPTY 0 /;
TRYAGAIN = TRUE;
$ONLISTING

LOOP(ATTEMPTS$TRYAGAIN,
	TRYAGAIN = FALSE;
	SOLVE MKMC MAXIMIZING UTILITY USING NLP;
	IF ( ((MKMC.MODELSTAT EQ 7) AND (MKMC.SOLVESTAT EQ 4)),
         	TRYAGAIN = TRUE;
        );
);

$OFFLISTING


