*GG* V1.3c add version control title
$TITLE ========== *** GAMS-MARKAL/MARKAL-MACRO -- VERSION 1.4e *** ===========
******************************************************************************
*                                                                            *
*  All Possible User and Internal Sets and Parameters Must be Declared and   *
*   Assigned Initial Psuedo Values.                                          *
******************************************************************************

*============================================================================*
*  Sets Without Much User Choice                                             *
*============================================================================*
         SET   BD        BOUND TYPE
             / FX        FIXED
               LO        LOWER
               UP        UPPER                                          /

         SET   RTY       ROW TYPES
             / FIX       EQUALITY (EQ)
               MAX       MAXIMUM (GE)
               MIN       MINIMUM (LE)
               OBJ       NON-BINDING                                    /

         SET   SRC       Sources of resources
             / EXP       EXPORT
               IMP       IMPORT
               MIN       EXTRACTION
               RNW       RENEWABLES
               STK       STOCKPILING                                    /

         SET   Y         TIME-OF-DAY
             / D         DAY
               N         NIGHT                                          /

         SET   Z         SEASONS
             / I         INTERMEDIATE
               S         SUMMER
               W         WINTER                                         /

         SET   TD(Z,Y)   SEASON+TIME-OF-DAY
             / I.D, I.N, S.D, S.N, W.D, W.N /

*GG* V1.2b all ALLORD set used for checking ordinality counting
         SET  ALLORD / 1*20 /;
*============================================================================*
*  MACRO Summary Table Reporting Lines                                       *
*============================================================================*
         SET RR REPORT ROWS / GDP, CON, INV, ENC /;

*============================================================================*
*  Initialized Scalar Defaults                                               *
*============================================================================*
         SCALARS
               NYRSPER   / 5. /
               STARTYRS  / 2.5 /
               DISCOUNT  / 0.05 /
               ERESERV   / 0 /
               ETRANINV  / 0 /
               ETRANOM   / 0 /
*GG* V1.0e add heating defaults
               DTRANOM   / 0 /
               DTRANINV  / 0 /
               DHDEW     / .92 /
               DHDEI     / .92 /
               DHDES     / .92 /
               TE        / 1 /
               EDISTINV  / 0 /
               EDISTOM   / 0 /
               BASELOAD  / 0.9 /
               HRESERV   / 0 /
               ELCFEQ    / 3.125 /
*GG* V1.1c add the no interpolation flag
               NOINTERP  / 0 /
* MACRO Scalars
               DEPR      / 5.00 /
               EC0       / 0.599 /
               ESUB      / 0.5 /
               EXPF      / 14.87 /
               GDP0      / 3.56 /
*               GROW      / 2.35 /
               KGDP      / 2.4 /
               KPVS      / 0.24 /
*               LOTOL     / 0.3 /
               QFAC      / 0.0 /
*GG* V1.0h change the hardwire .001/1000 scaling to us MMSCALE
               MMSCALE   / 1 /
*GG* V1.4e use seperate scaler for emissions
               ENV_SCAL   / 1 /
*GG* V1.0h add demand lower bound factor and IVE multiplier
               DMTOL     / 1.0 /
               IVETOL    / 0.5 /
*GG* V1.2b collapse and differential cost defaults are turned off
               COLLAPSE  / 0 /
               DIFFDMDS  / 0 /
               FRSB     / 0 /
*GG* V1.4a set up for automatic ENV tax iteration, ITER1*ITER3 for 3 extra loop
          SET   ENV_ITER  / EMPTY /
*         SET   YRS   / 1*5 /
*         SET   YRS   / 1*10 /

*============================================================================*
*  Set a +/- Sign According to the Supply Options Constribution              *
*============================================================================*
         PARAMETER SIGN(SRC) / (MIN,IMP,RNW,STK) 1, EXP -1 /;

*============================================================================*
*  Create a Psuedo Value (NULL) to Initialize Sets & Parameters              *
*============================================================================*
$PHANTOM EMPTY

*============================================================================*
*  Declare/Initialize User Defined Sets                                      *
*============================================================================*
         SET ADRATIO / EMPTY /;
         SET YEAR / EMPTY /;
         SET DM / EMPTY /;
         SET ENV / EMPTY /;
* TP controls which year execution will proceed for and is now set in *.GEN
*         SET TP / EMPTY /;
*GG* init empty for technologies
         SET TCH / EMPTY /;
         SET DMD(TCH) / EMPTY /;
         SET PRC(TCH) / EMPTY /;
         SET CON(TCH) / EMPTY /;
         SET ELE(CON) / EMPTY /;
         SET CPD(CON) / EMPTY /;
         SET HPL(CON) / EMPTY /;
         SET STG(CON) / EMPTY /;
         SET BAS(CON) / EMPTY /;
         SET CEN(CON) / EMPTY /;
         SET DCN(CON) / EMPTY /;
         SET FOS(CON) / EMPTY /;
         SET HDE(CON) / EMPTY /;
         SET NUC(CON) / EMPTY /;
*GG* V1.1c add the nuclear report controller
         SET NUR(*) / EMPTY /;
         SET DUM(TCH) / EMPTY /;
         SET REN(CON) / EMPTY /;
         SET RNT(TCH) / EMPTY /;
         SET NST(TCH) / EMPTY /;
         SET XPR(PRC) / EMPTY /;
         SET XLM(CON) / EMPTY /;

         SET ENT / EMPTY /;
         SET ENC(ENT) / EMPTY /;
         SET ECV(ENC) / EMPTY /;
         SET EFS(ENC) / EMPTY /;
*GG* V1.0i add EHC
         SET EHC(ENC) / EMPTY /;
         SET ENU(ENC) / EMPTY /;
         SET ERN(ENC) / EMPTY /;
         SET ERNXMAC(ERN) / EMPTY /;
         SET ESY(ENC) / EMPTY /;
         SET SLD(ENC) / EMPTY /;
         SET GAZ(ENC) / EMPTY /;
         SET LIQ(ENC) / EMPTY /;
         SET P / EMPTY /;
         SET SEP(SRC,ENT,P) / EMPTY.EMPTY.EMPTY /;
*GG* V1.0 add nlm
         SET NLM(CON) / EMPTY /;
*GG* V1.4b+ initialize DMD_DM
         SET DMD_DM(DMD,DM) / EMPTY.EMPTY /;
*GG* V1.4e add TAXSUB
         SET TAXSUB / EMPTY /;

*============================================================================*
*  Declare/Initialize XPR Control Sets                                       *
*============================================================================*
*GG* V1.0e add ypr/zpr which were not declared before
         SET YPR(PRC) / EMPTY /;
         SET ZPR(PRC) / EMPTY /;

*============================================================================*
*  Declare/Initialize Parameters                                             *
*============================================================================*
* Fuel used by conversion technologies
     PARAMETERS CON_INP1(CON,ENT,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Fuel required by conversion technologies at startup
     PARAMETERS CON_INP2(CON,ENC) / EMPTY.EMPTY 0 /;
* Auxilary fuel produced by conversion technologies
     PARAMETERS CON_OUT(CON,ENC,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
*GG* V1.1a add CPD parameters
* Electricity lost pre unit of heat for pass-out turbines
     PARAMETERS CPD_CEH(CPD,Z,Y) / EMPTY.EMPTY.EMPTY 0 /;
* Limit on reduction of electricity for pass-out turbines
     PARAMETERS CPD_ELM(CPD) / EMPTY 0 /;
* Units of electriciy per unit of heat produced for back-pressure turbines
     PARAMETERS CPD_REH(CPD) / EMPTY 0 /;
* Transmission eff. loss for heat produced from centralized coupled prod. plants
     PARAMETERS CPD_TEFF(CPD,Z,Y) / EMPTY.EMPTY.EMPTY 0 /;
* District heating seasonal distribution efficiency
     PARAMETERS DHDE(Z) / EMPTY 0 /;
* MACRO Sectoral Demand PREF and AEEIs
     PARAMETERS DDAT(DM,*) / EMPTY.EMPTY 0 /;
*GG* V1.2 change AEEIs -> DDF with time dependancy
     PARAMETERS DDF(DM,YEAR) / EMPTY.EMPTY 0 /;
* Sectoral Demands
     PARAMETERS DM_DEMAND(DM,YEAR) / EMPTY.EMPTY 0 /;
* Fraction of Demand Capacity to Peaking
     PARAMETERS DM_ELF(DM,YEAR) / EMPTY.EMPTY 0 /;
* Seasonal Fraction of Demands
     PARAMETERS DM_FR(DM,Z,Y) / EMPTY.EMPTY.EMPTY 0 /;
* Demands Split by QHR(Z)(Y)
     PARAMETERS DM_UNIFDIS(DM) / EMPTY 0 /;
* Efficiency of Demand Devices
     PARAMETERS DMD_EFF(DMD,YEAR) / EMPTY.EMPTY 0 /;
* Input Fuel to Demand Devices
     PARAMETERS DMD_MA(DMD,ENT,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Output from Demand Devices to a Seperate Demand Sector
     PARAMETERS DMD_OUT(DMD,DM,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Auxilary Fuel from Demand Devices
*GG* V1.0i add energy carrier from demand devices
     PARAMETERS DMD_MO(DMD,ENC,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Upper Bounds on Emissions
     PARAMETERS EM_BOUND(ENV,YEAR) / EMPTY.EMPTY 0 /;
* Emission from Supply Options
     PARAMETERS ENV_TSEP(ENV,SRC,ENT,P,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Emission from Technologies
     PARAMETERS ENV_TACT(ENV,TCH,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
*GG* V1.0g add the rest of the emission tracking options
* Emission from Technologies Capacity
    PARAMETERS ENV_CAP(ENV,TCH,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Emission from Technologies Investment
    PARAMETERS ENV_INV(ENV,TCH,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Emission Costs
    PARAMETERS ENV_COST(ENV,YEAR) / EMPTY.EMPTY 0 /;
* Emission_Tax_Revenues for adjusting EC
    PARAMETERS ENV_TAX(ENV,YEAR) / EMPTY.EMPTY 0 /;
*  Cumulative Emissions Limit
    PARAMETERS ENV_CUM(ENV) / EMPTY 0 /;
* Emissions Global Warming
    PARAMETERS ENV_GWP(ENV,ENV,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Market Penetration Cutoff for Applying Cost Penalty
    PARAMETERS EXPBND(TCH,YEAR) / EMPTY.EMPTY 0 /;
* Labor Productivity Growth Rate for MACRO
    PARAMETERS GROWV(YEAR) / EMPTY 0 /;
* Conversion Technology Peaking Factor
    PARAMETERS PEAK1(CON,YEAR) / EMPTY.EMPTY 0 /;
*GG* V1.1a add PEAK TID for peaking only devices
    PARAMETERS PEAK_TID(CON) / EMPTY 0 /;
*GG* V1.1a add PEAKDA for processes using electricity
    PARAMETERS PEAKDA_PRC(PRC, YEAR) / EMPTY.EMPTY 0 /;
*GG* V1.1a add PEAKDA for supply options using electricity and exports
    PARAMETERS PEAKDA_SEP(SRC, ENT, P, YEAR) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Season/Time-of-Day Fractions
    PARAMETERS QHR(Z,Y) / EMPTY.EMPTY 0 /;
*GG* V1.0i add a season total
    PARAMETERS QHRZ(Z) / EMPTY 0 /;
* Fuel Used by Processes
    PARAMETERS PRC_INP2(PRC,ENT,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Fuel Output from Processes in the Next Period
    PARAMETERS PRC_LAG(PRC,ENC,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Input for Process in the Previous Period
    PARAMETERS PRC_LED(PRC,ENT,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
*GG* V1.1a Limit Processes
    PARAMETERS PRC_LIM(PRC,YEAR) / EMPTY.EMPTY 0 /;
* Fuel Produced by Processes
    PARAMETERS PRC_OUT(PRC,ENC,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Ratio Equation Based Upon Capacity
    PARAMETERS RAT_CAP(ADRATIO,TCH,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Ratio Equation Based Upon Activity of Processes
    PARAMETERS RAT_ACT(ADRATIO,PRC,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Ratio Equation for Seasonal Activity of Elec. Conv. Technology
    PARAMETERS RAT_TEZY(ADRATIO,CON,Z,Y,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY.EMPTY 0 /;
*GG* V1.1a coupled production heat variable
     PARAMETERS RAT_TCZY(ADRATIO,CPD,Z,Y,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY.EMPTY 0 /;
*GG* V1.1c add the nuclear report controller
     PARAMETERS REACTORS(TCH,NUR) / EMPTY.EMPTY 0 /;
* Ratio Equation for Seasonal Activity of Heat. Conv. Tech.
*GG* V1.0h add ADRATIO heating plants
    PARAMETERS RAT_HPL(ADRATIO,HPL,Z,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;
*GG* V1.1a  Ratio Equation for Investment
    PARAMETERS RAT_INV(ADRATIO,TCH,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Ratio Equation for Resource Supply Options
    PARAMETERS RAT_TSEP(ADRATIO,SRC,ENT,P,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Ratio Equation Type
    PARAMETERS RAT_RTY1(ADRATIO,RTY) / EMPTY.EMPTY 0 /;
* Ratio Equation RHS Value
    PARAMETERS RAT_RTY2(ADRATIO,RTY,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Bound on Resource Supply Level
    PARAMETERS SEP_BOUND(SRC,ENT,P,BD,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Cost of Resource Supply
    PARAMETERS SEP_COST1(SRC,ENT,P,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Cumulative Limit for Resource Supply
    PARAMETERS SEP_CUM(SRC,ENT,P) / EMPTY.EMPTY.EMPTY 0 /;
*GG* V1.1a Supply Growth Contraint
    PARAMETERS SEP_GRTID(SRC,ENT,P) / EMPTY.EMPTY.EMPTY 0 /;
    PARAMETERS SEP_TGR(SRC,ENT,P,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Fuel Input to Resource Supply
*GG* V1.0i add input fuels & associated delivery costs
    PARAMETERS SEP_INP(SRC,ENT,P,ENT,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Delivery Cost for Fuel Input to Resource Supply
    PARAMETERS SEP_DELIV(SRC,ENT,P,ENT,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Season/Time-of-Day for Elec. to Resource Supply
*GG* V1.0e add handling of import/export of electricity
    PARAMETERS SEP_FR(SRC,P,Z,Y) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Security Factor for Resource Supply
    PARAMETERS SEP_SECURI(SRC,ENT,P,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Initial Year Resource Supply Available
    PARAMETERS SEP_START(SRC,ENT,P) / EMPTY.EMPTY.EMPTY 0 /;
* Salvage Value of Stockpiled Resource Supply
    PARAMETERS SEP_STKCOS(SRC,ENC,P) / EMPTY.EMPTY.EMPTY 0 /;
* Technology Availability Factor
    PARAMETERS TCH_AF1(TCH,YEAR) / EMPTY.EMPTY 0 /;
* Technology Forced Outage
    PARAMETERS TCH_AF2(TCH) / EMPTY 0 /;
* Technology Seasonal Availablity Factor
    PARAMETERS TCH_AF3(TCH,Z,Y,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Technology Capacity Bound
    PARAMETERS TCH_BOUND(TCH,BD,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Technology Investment Bound
    PARAMETERS TCH_IBND(TCH,BD,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Technology Activity Bound
    PARAMETERS TCH_BNDO(TCH,BD,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Technology Capacity Unit
    PARAMETERS TCH_CAPUNI(TCH) / EMPTY 0 /;
* Technology Capacity Seasonal Utilization Factor
    PARAMETERS TCH_CF1(TCH,Z,Y,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;
* Average Utilization Factor of Capacity
*GG*? change TCH to DMD
    PARAMETERS TCH_CF2(TCH,YEAR) / EMPTY.EMPTY 0 /;
* Delivery Cost for Fuels Used by Technologies
    PARAMETERS TCH_DELIV(TCH,ENT,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Technology Based Discount Rate
*GG* V1.0f add differential discount rates
    PARAMETERS TCH_DISC(TCH) / EMPTY 0 /;
* Technology Fixed O&M Costs
    PARAMETERS TCH_FIXOM(TCH,YEAR) / EMPTY.EMPTY 0 /;
*GG* V1.1a Technology Growth Contraint
    PARAMETERS TCH_GRTID(TCH) / EMPTY 0 /;
    PARAMETERS TCH_TGR(TCH,YEAR) / EMPTY.EMPTY 0 /;
* Technology Investment Costs
    PARAMETERS TCH_INVCOS(TCH,YEAR) / EMPTY.EMPTY 0 /;
* Lifetime of Technology
    PARAMETERS TCH_LIFE(TCH) / EMPTY 0 /;
*GG* V1.1a add peak duration factors
    PARAMETERS TCH_PD(CON,Z,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
* Residual Capacity of Technology
    PARAMETERS TCH_RESID(TCH,YEAR) / EMPTY.EMPTY 0 /;
* Initial Year Technology Available
    PARAMETERS TCH_START(TCH) / EMPTY 0 /;
* Technology Variable Costs
    PARAMETERS TCH_VAROM(TCH,YEAR) / EMPTY.EMPTY 0 /;
* Transmission Efficiency of Fuels
*GG* V1.0i add transmission efficiency by energy carrier
    PARAMETERS TEENC(ENC) / EMPTY 0 /;
*GG* V1.2b add differential costing input table
    PARAMETERS DIFFCOST(DM,YEAR) / EMPTY.EMPTY 0 /;
    PARAMETERS DIFF_DM(DM) / EMPTY 0 /;

*GG* V1.4e add Tax/Subsidy parameters
    PARAMETERS TSUB_ENT(TAXSUB,ENT) / EMPTY.EMPTY 0 /;
    PARAMETERS TSUB_COST(TAXSUB,YEAR) / EMPTY.EMPTY 0 /;
    PARAMETERS TSUB_BND(TAXSUB,BD,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
    PARAMETERS TSUB_TCH(TAXSUB,TCH,YEAR) / EMPTY.EMPTY.EMPTY 0 /;
    PARAMETERS TSUB_SEP(TAXSUB,SRC,ENT,P,YEAR) / EMPTY.EMPTY.EMPTY.EMPTY.EMPTY 0 /;
    PARAMETERS TSUB_TOT(TAXSUB,YEAR) / EMPTY.EMPTY 0 /;

*GG* V1.4e user & intermediate MARKAL-MICRO parameters
    PARAMETERS PARDD(DM,*) / EMPTY.EMPTY 0 /;
    PARAMETERS SHFTDD(DM,YEAR) / EMPTY.EMPTY 0 /;
    PARAMETERS SHFTPAR(DM,YEAR) / EMPTY.EMPTY 0 /;
    PARAMETERS ELP(DM) / EMPTY 0 /;
    PARAMETERS CCONS(DM) / EMPTY 0 /;
    PARAMETERS DMMIN(DM) / EMPTY 0 /;

*=============================================================================*
*  Intermediate Scalars for MARKAL-MACRO                                      *
*=============================================================================*
SCALARS
  ASRV   annual capital survival factor
  C0     initial consumption
*  GDP0   initial gdp ($ trillions)
  IV0    initial investment
  K0     initial capital
  RHO    exponent derived from esub
  TSRV   yearly capital survival factor according to number of years per period
  Y0     initial gross output
  YCHECK
  AKL    prod function constant for k-l index
;

*============================================================================*
*  Intermediate Parameters for MARKAL-MACRO                                  *
*============================================================================*

*GG* V1.1a move the costing stuff from MMCOEF->MMACRO so init here
  PARAMETER ICOST(YEAR, TCH) initial invest costs / EMPTY.EMPTY 0 /;
  PARAMETER COST_INV(YEAR, YEAR, TCH) annualized invest / EMPTY.EMPTY.EMPTY 0 /;
  PARAMETERS AEEIV(DM,YEAR)    aeei values  / EMPTY.EMPTY 0 /;
  PARAMETERS AEEIFAC(DM,YEAR)  aeei factor / EMPTY.EMPTY 0 /;
  PARAMETERS B(DM)           prod function constants for useful energy / EMPTY 0 /;
  PARAMETERS CAPTB(TCH)      base year capacity values for expanding technologies / EMPTY 0 /;
  PARAMETERS D0(DM)          base year final demands - from markal / EMPTY 0 /;
  PARAMETERS DFACTCURR(YEAR)   current annual utility discount factor / EMPTY 0 /;
  PARAMETERS DFACT(YEAR)       utility discount factor / EMPTY 0 /;
  PARAMETERS L(YEAR)           current labor force (efficiency units) / EMPTY 0 /;

*============================================================================*
*  Results Parameters for MARKAL-MACRO                                       *
*============================================================================*
  PARAMETERS AD(YEAR,DM) AEEI * DEMANDS  / EMPTY.EMPTY 0 /;
  PARAMETERS MC(YEAR,DM) MARGINAL COSTS OF ENERGY DEMANDS - DOLLARS PER GJ   / EMPTY.EMPTY 0 /;
  PARAMETERS CRT(YEAR,ENV)  VALUE OF EMISSION RIGHTS - DOLLARS PER TON   / EMPTY.EMPTY 0 /;
  PARAMETERS GDP(YEAR)  GROSS DOMESTIC PRODUCT   / EMPTY 0 /;
  PARAMETERS CAPMARG(YEAR,TCH) MARGINAL COST OF CAPACITIES / EMPTY.EMPTY 0 /;
*GG* V1.1a introduce place holder for 'E'lectic, 'H'eat, 'P'rocess
  PARAMETERS ACTVALS(YEAR,*,TCH) ACTIVITIES / EMPTY.EMPTY.EMPTY 0 /;
  PARAMETERS SUPMARG(YEAR,SRC,ENT,P)  SUPPLY ACTIVITIES / EMPTY.EMPTY.EMPTY.EMPTY 0 /;
  PARAMETERS C(YEAR)  consumption - trillion dollars / EMPTY 0 /;
  PARAMETERS KBND(YEAR)     flag for lower bound on capital / EMPTY 0 /;
  PARAMETERS DBND(DM, YEAR) flag for lower bound on demands / EMPTY.EMPTY 0 /;
  PARAMETERS IEBND(YEAR)    flag for upper bound on sum of investment and energy costs / EMPTY 0 /;
  PARAMETERS XCAPREP(TCH,YEAR) market penetration bounds - additional capacity /EMPTY.EMPTY 0/;
  PARAMETERS CO2(YEAR)         CO2 emissions (million tons) / EMPTY 0 /;
  PARAMETERS VALUEREP(RR, YEAR) summary report / EMPTY.EMPTY 0 /;
*GG* V1.3b adjust the indexing of the growth rates reported in the *.LST file
  PARAMETERS GG(RR,YEAR) 'annual growth rates, 1st period->2nd = 1st' / EMPTY.EMPTY 0 /;
  PARAMETERS GROWTHREP(RR, *) summary of annual growth rates / EMPTY.EMPTY 0 /;
