$OFFLISTING
*$ONLISTING
*******************************************************************************
*                                                                             *
*  This is the MARKAL report writer.  GAMS PUT statements are used to output  *
*   results in a standard format for importing into MUSS.  Since the PUT      *
*   statement does not allow any calculations to be performed they must be    *
*   done beforehand and stored in intermediate tables.  The PARAMETERS are    *
*   declared and initialized in MMINIT.INC.                                   *
*  PARMAETERS                                                                 *
*DVR/GG* V1.4e, introduce MARKAL-MICRO support (same as MARKAL)
*    %1 - GMARKAL or MARKAL-MACRO or MARKAL-MICRO                              *
*GG* V1.1c = Common MARKAL MUSS analysis tables                               *
*******************************************************************************
SCALAR DPTS;

*******************************************************************************
*                                                                             *
*  Setup the MUSS Results Table File and print configuration                  *
*                                                                             *
*******************************************************************************
$BATINCLUDE ATFILE.INC ANALTABS

*=============================================================================*
* TABLE T01 - Scenario Indicators
*=============================================================================*
SCALAR TOT_NOTAX, TOT_ENV, TOT_SEC, EMTAX;
$BATINCLUDE RW01.INC %1

*=============================================================================*
* Calculate MARKAL-MACRO tables, perform basic displays and output specifics
*=============================================================================*
$IF %1 == 'MARKAL-MACRO' $INCLUDE MMREPORT.MM

*=============================================================================*
*  Demand Levels                                                              *
*=============================================================================*
IF (1$RUNRPTS('DEMAND'),
$BATINCLUDE RWDEM.INC %1
);

*GG* V1.4b re-organize to make adding other sectors easier
* establish the subset of DMs in each sector

* Non-Energy
SET NE(DM) / EMPTY /;
SET DMDN(DMD) / EMPTY /;
SET ALLNE(*) / NA,NB,NC,ND,NE,NF,NG,NH,NI,NJ,NK,NL,NM,NN,NO,NP,NQ,NR,NS,NT,NU,
                 NV,NW,NX,NY,NZ,N0,N1,N2,N3,N4,N5,N6,N7,N8,N9 /;
NE(DM)$ALLNE(DM) = YES;
*GG* V1.4e include the devices servicing alternate demands across 2 sectors
*DMDN(DMD)$SUM(NE,DMD_DM(DMD,NE)) = YES;
DMDN(DMD)$SUM(NE,DMD_DMS(DMD,NE)) = YES;

* Residential (& Commercial)
SET RC(DM) / EMPTY /;
SET DMDR(DMD) / EMPTY /;
SET ALLRC(*) / RA,RB,RC,RD,RE,RF,RG,RH,RI,RJ,RK,RL,RM,RN,RO,RP,RQ,RR,RS,RT,RU,
                 RV,RW,RX,RY,RZ,R0,R1,R2,R3,R4,R5,R6,R7,R8,R9 /;
RC(DM)$ALLRC(DM) = YES;
*GG* V1.4e include the devices servicing alternate demands across 2 sectors
*DMDR(DMD)$SUM(RC,DMD_DM(DMD,RC)) = YES;
DMDR(DMD)$SUM(RC,DMD_DMS(DMD,RC)) = YES;

* Transportation
SET TRN(DM) / EMPTY /;
SET DMDT(DMD) / EMPTY /;
SET ALLTRN(*) / TA,TB,TC,TD,TE,TF,TG,TH,TI,TJ,TK,TL,TM,TN,TO,TP,TQ,TR,TS,TT,TU,
                 TV,TW,TX,TY,TZ,T0,T1,T2,T3,T4,T5,T6,T7,T8,T9 /;
TRN(DM)$ALLTRN(DM) = YES;
*GG* V1.4e include the devices servicing alternate demands across 2 sectors
*DMDT(DMD)$SUM(TRN,DMD_DM(DMD,TRN)) = YES;
DMDT(DMD)$SUM(TRN,DMD_DMS(DMD,TRN)) = YES;

* Industry
SET IND(DM) / EMPTY /;
SET DMDI(DMD) / EMPTY /;
SET ALLIND(*) / IA,IB,IC,ID,IE,IG,IH,II,IJ,IK,IL,IM,IN,IO,IP,IQ,IR,IS,IT,IU,
                 IV,IW,IX,IY,IZ,I0,I1,I2,I3,I4,I5,I6,I7,I8,I9 /;
IND(DM)$ALLIND(DM) = YES;
*GG* V1.4e include the devices servicing alternate demands across 2 sectors
*DMDI(DMD)$SUM(IND,DMD_DM(DMD,IND)) = YES;
DMDI(DMD)$SUM(IND,DMD_DMS(DMD,IND)) = YES;

*GG* V1.4b add C-Commercial and A-Agriculture
* Commercial
SET COM(DM) / EMPTY /;
SET DMDC(DMD) / EMPTY /;
SET ALLCOM(*) / CA,CB,CC,CD,CE,CG,CH,CI,CJ,CK,CL,CM,CN,CO,CP,CQ,CR,CS,CT,CU,
                 CV,CW,CX,CY,CZ,C0,C1,C2,C3,C4,C5,C6,C7,C8,C9 /;
COM(DM)$ALLCOM(DM) = YES;
*GG* V1.4e include the devices servicing alternate demands across 2 sectors
*DMDC(DMD)$SUM(COM,DMD_DM(DMD,COM)) = YES;
DMDC(DMD)$SUM(COM,DMD_DMS(DMD,COM)) = YES;

* Agriculture
SET AGR(DM) / EMPTY /;
SET DMDA(DMD) / EMPTY /;
SET ALLAGR(*) / AA,AB,AC,AD,AE,AG,AH,AI,AJ,AK,AL,AM,AN,AO,AP,AQ,AR,AS,AT,AU,
                 AV,AW,AX,AY,AZ,A0,A1,A2,A3,A4,A5,A6,A7,A8,A9 /;
AGR(DM)$ALLAGR(DM) = YES;
*GG* V1.4e include the devices servicing alternate demands across 2 sectors
*DMDA(DMD)$SUM(AGR,DMD_DM(DMD,AGR)) = YES;
DMDA(DMD)$SUM(AGR,DMD_DMS(DMD,AGR)) = YES;

PARAMETER INVDISC(TP) / EMPTY 0 /;
INVDISC(TP) = 1 / ((1 + DISCOUNT) ** (- STARTYRS + NYRSPER * (ORD(TP)-1)));
*=============================================================================*
* TABLE T02 - Summary
*=============================================================================*
SET T02ENC(*) / EMPTY /;
SET IMPEXP(SRC) / IMP, EXP /;
PARAMETERS T02(TP,*,*) / EMPTY.EMPTY.EMPTY 0 /;
PARAMETERS T02S(TP,SRC,ENT,P) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;

IF (1$RUNRPTS('T02'),
$BATINCLUDE RW02.INC %1
);

SET NO_ENUERN(ENC) / EMPTY /;
NO_ENUERN(ENC)$(NOT (1$ENU(ENC) OR 1$ERN(ENC))) = YES;
*=============================================================================*
* TABLE T03 - Primary Energy Supply
*=============================================================================*
SET T03ENC(*) / EMPTY /;
SET T03FOS(*) / EMPTY /;
SET T03RNW(*) / EMPTY /;
PARAMETERS T03(TP,*,*) / EMPTY.EMPTY.EMPTY 0 /;
PARAMETERS T03E(TP,*,*,*) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;

IF (RUNRPTS('T03'),
$INCLUDE RW03.INC
);

*=============================================================================*
* TABLE T04 - Energy Output of Each Supply Technology at Gate
*=============================================================================*
PARAMETERS T04(TP,*,*) / EMPTY.EMPTY.EMPTY 0 /;
SET CON_BYP(CON) / EMPTY /;
SET THE_DMD(DMD) / EMPTY /;
SET CEN_DCN(ELE) / EMPTY /;
SET EFS_SLD(ENC) / EMPTY /;
SET EFS_LIQ(ENC) / EMPTY /;
SET EFS_GAZ(ENC) / EMPTY /;
SET ANY_ENC(ENC) / EMPTY /;
SET THE_PRC(PRC) / EMPTY /;
* identify main outputs
SET MAIN_ENC(PRC,ENC) / EMPTY.EMPTY /;
SET CK_ENC(ENC) / EMPTY /;
SET BIG_ENC(ENC) / EMPTY /;
PARAMETER CNT_OUT(ENC) / EMPTY 0 /;
PARAMETER CK_FRAC(ENC) / EMPTY 0 /;
SCALAR  FRAC_OUT / 0 /;

IF (RUNRPTS('T04'),
$INCLUDE RW04.INC
);

*=============================================================================*
* TABLE T05 - Fuel Consumption by Demand Sector
*=============================================================================*
PARAMETERS T05(TP,*,*) / EMPTY.EMPTY.EMPTY 0 /;
*GG* V1.2b add demand device/energy carrier list
SET DD_ALL(DMD,ENC);
*GG* V1.4e use set union
*DD_ALL(DMD,ENC)$(1$DD_MA(DMD,ENC) OR 1$DD_MO(DMD,ENC)) = YES;
DD_ALL(DMD,ENC)$(DD_MA(DMD,ENC) + DD_MO(DMD,ENC)) = YES;

IF (RUNRPTS('T05'),
$INCLUDE RW05.INC
);

DMDN(DMD)$SUM(NE,DMD_DMS(DMD,NE)) = YES;
DMDR(DMD)$SUM(RC,DMD_DMS(DMD,RC)) = YES;
DMDT(DMD)$SUM(TRN,DMD_DMS(DMD,TRN)) = YES;
DMDI(DMD)$SUM(IND,DMD_DMS(DMD,IND)) = YES;
*GG* V1.4b add C-Commercial and A-Agriculture
DMDC(DMD)$SUM(COM,DMD_DMS(DMD,COM)) = YES;
DMDA(DMD)$SUM(AGR,DMD_DMS(DMD,AGR)) = YES;
*=============================================================================*
* TABLE T06 - Useful Energy from Each Demand Device
*=============================================================================*
PARAMETERS T06(TP,*,*) / EMPTY.EMPTY.EMPTY 0 /;

IF (RUNRPTS('T06'),
$INCLUDE RW06.INC
);

*=============================================================================*
* TABLE T08 - Production and Use of Energy Carriers
*GG* V1.3b added
*=============================================================================*
PARAMETERS T08(ENT,*,TP) / EMPTY.EMPTY.EMPTY 0 /;

IF (RUNRPTS('T08'),
$INCLUDE RW08.INC
);

*=============================================================================*
* TABLE T09 - Shadow Prices of Energy Carriers
*=============================================================================*
PARAMETERS T09(TP,*,*) / EMPTY.EMPTY.EMPTY 0 /;

IF (RUNRPTS('T09'),
$IF %1 == 'GMARKAL' $INCLUDE RW09.MRK
$IF %1 == 'MARKAL-MACRO' $INCLUDE RW09.MM
*DVR/GG* V1.4e, introduce MARKAL-MICRO support (same as MARKAL)
$IF %1 == 'MARKAL-MICRO' $INCLUDE RW09.MRK
);

*=============================================================================*
* TABLE T11 - Shadow Prices of Supply, Technology Capacities and Emissions
*=============================================================================*
SET RW11RAT(ADRATIO);

IF (RUNRPTS('T11'),
$IF %1 == 'GMARKAL' $INCLUDE RW11.MRK
$IF %1 == 'MARKAL-MACRO' $INCLUDE RW11.MM
*DVR/GG* V1.4e, introduce MARKAL-MICRO support
$IF %1 == 'MARKAL-MICRO' $INCLUDE RW11.MI
);

*=============================================================================*
* TABLE T25 - Annual Costs
*=============================================================================*
*GG* V1.3a new
SET XSTK(SRC,ENT,P) / EMPTY.EMPTY.EMPTY /;

IF (RUNRPTS('T25'),
$BATINCLUDE RW25.INC %1
);

*=============================================================================*
* TABLE T27 - Annual Environmental Effects
*=============================================================================*
PARAMETERS T27(TP,*,*) / EMPTY.EMPTY.EMPTY 0 /;
PARAMETERS T27T(TP,*,*) / EMPTY.EMPTY.EMPTY 0 /;
PARAMETERS T27S(TP,SRC,ENT,P) / EMPTY.EMPTY.EMPTY.EMPTY 0 /;
SET XDMD(DMD) / EMPTY /;

IF (RUNRPTS('T27'),
$INCLUDE RW27.INC
);

*=============================================================================*
* Detail Tables CAP, INV and SUPPLY
*=============================================================================*
*GG* V1.4a add full costing row to INV table
*GG* V1.4f expand the CAP table == T23
PARAMETERS FULLCOST(TP,DMD) / EMPTY.EMPTY 0 /;
PARAMETERS CAPDET(TP,*,*,*,TCH) / EMPTY.EMPTY.EMPTY.EMPTY.EMPTY 0 /;
$INCLUDE RWDET.INC
OPTION CLEAR = FULLCOST;
OPTION CLEAR = CAPDET;

*=============================================================================*
* COSTBENefit
*=============================================================================*
SET TCHX(TCH) / EMPTY /;
SET CONX(CON) / EMPTY /;
SET ELAX(CON) / EMPTY /;
SET ELX(CON) / EMPTY /;
SET CPX(CPD) / EMPTY /;
SET HPX(HPL) / EMPTY /;
SET PRX(PRC) / EMPTY /;
SET DMX(DMD) / EMPTY /;
SET TCH_ENC(TCH,ENT) / EMPTY.EMPTY /;
PARAMETERS MULT(TP) / EMPTY 0 /;
PARAMETERS CB(TP,TCH) / EMPTY.EMPTY 0 /;
PARAMETERS SINK(TP,TCH) / EMPTY.EMPTY 0 /;
PARAMETERS FLOW(TP,TCH) / EMPTY.EMPTY 0 /;
PARAMETERS RATIO(TP,TCH) / EMPTY.EMPTY 0 /;
PARAMETERS SINKT(TCH) / EMPTY 0 /;
PARAMETERS FLOWT(TCH) / EMPTY 0 /;
PARAMETERS RATIOT(TCH) / EMPTY 0 /;
$INCLUDE COSTBEN.DD
IF (RUNRPTS('COSTBEN'),
* Get the list of technologies to be handled
$BATINCLUDE COSTBEN.INC %1
);

OPTION CLEAR = NE;
OPTION CLEAR = RC;
OPTION CLEAR = TRN;
OPTION CLEAR = IND;
OPTION CLEAR = DMDI;
OPTION CLEAR = DMDR;
OPTION CLEAR = DMDT;
OPTION CLEAR = DMDN;
*GG* V1.4b make sure to get ride of all DM sector sets
OPTION CLEAR = COM;
OPTION CLEAR = AGR;
OPTION CLEAR = DMDC;
OPTION CLEAR = DMDA;

OPTION CLEAR = NO_ENUERN;
OPTION CLEAR = INVDISC;
