******************************************************************************
*  Create any Combined Sets Needed for Execution                             *
******************************************************************************
*GG*? no alternate DM outs allowed?
*GG* V1.0g change to YEAR
*PARAMETER DMD_OUT(DMD, DM, YEAR);
*  DMD_OUT(DMD, DM, TP) = 0;
*GG* v1.0i allow for output to other DMs, move to MMFILL after interpolate
*  DMD_OUT(DMD_DM(DMD, DM), TP)$(NOT DMD_OUT(DMD, DM, TP)) = 1;

* Need some temporary values
SCALARS
  GAP
  IFIRST
  ILAST
  VFIRST
  VLAST
  VPREV
;

*============================================================================*
*  Declare the conditional/union/intersection sets                           *
*============================================================================*
SETS
* Projection Periods
  TT(TP)       / EMPTY /
* Base Year
  TB(TP)       / EMPTY /
* Last Year
  TLAST(TP)    / EMPTY /
* Combination of Conversion Technologies and Processes
  PON(TCH)     / EMPTY /
*SK
* set of subsidized technologies
  BEW(TCH)     / EMPTY /
*SK
* Night-Storage Processes
  PRCNST(PRC)  / EMPTY /
* Night-Storage Demand Devices
  DMDNST(DMD)  / EMPTY /
* Electricity Conversion Technologies
  ELA(CON)     / EMPTY /
* Base-load Nuclear Plants
  BASNUC(CON)  / EMPTY /
* Centralized Base-load Plants
  CENBAS(CON)  / EMPTY /
*  CENELE(CON)  Centralized Electric Plants
*  DCNELE(CON)  Decentralized Electric Plants
*GG* V1.1a add CPDs
* Centralized Coupled Procudtion Plants
  CENCPD(CPD)  / EMPTY /
* Decentralized Coupled Production Plants
  DCNCPD(CPD)  / EMPTY /
* Base-load Coupled Production Plants
  CPDBAS(CPD)  / EMPTY /
* Base-load Electric Plants
  ELABAS(CON)  / EMPTY /
* Centralized Electric Plants
  ELACEN(CON)  / EMPTY /
*  ELADCN(CON) Decentralized Electric Plants
* Nuclear Electric Plants
  ELANUC(CON)  / EMPTY /
* Storage Electric Plants
  ELASTG(CON)  / EMPTY /
* Electric Non-base-load Plants
  ELAXBAS(CON) / EMPTY /
* Electric Externally Load Managed Plants
  ELAXLM(CON)  / EMPTY /
*  ELABASCEN(CON) Base-load Centralized Electric Plants
*  ELABASDCN(CON) Base-load Decentralized Electric Plants
*  ELAXLMBAS(CON) Base-load Externally Load Managed Plants
*  ELAXLMCEN(CON) Centralized Externally Load Managed Plants
*  ELAXLMDCN(CON) De-centralized Externally Load Managed Plants
* Storage Externally Load Managed Plants
  ELAXLMSTG(CON) / EMPTY /
* Nuclear Externally Load Managed Plants
  NUCXLM(CON)    / EMPTY /
*GG* V1.0e add imp/exp electricity,  Import and Export of Electricity
  IMPEXPELC(SRC, P) / EMPTY.EMPTY /
*GG* V1.0e add heating plant, Externally Load Managed Heating Plants
  HPLXLM(CON)    / EMPTY /
*GG* V1.1c add the renewable accounting class
  MAC(ENC) / EMPTY /
*GG* V1.1a add a class to reset BAS+STG at night
*  BAS_STG(CON, Z, Y)   / EMPTY.EMPTY.EMPTY /
*GG* V1.0i add set for Intermediate season exception testing
* Seasons with Intermediate
  ZNOTI(Z)       / EMPTY /  ;


*GG* V1.0i add set for ELC exception testing, *GG* V1.1c add ENT for reports
  SET   ELC(ENT)  ELECTRICITY
      / ELC       ELECTRICITY          /;

  SET   LTH(ENT)  LOW-TEMPERATURE HEAT
      / LTH       LOW-TEMPERATURE HEAT /;


*============================================================================*
*  Build the conditional/union/intersection sets                             *
*============================================================================*

  TT(TP)$(ORD(TP) NE 1) = YES;
  TB(TP)$(ORD(TP) EQ 1) = YES;
  TLAST(TP)$(ORD(TP) EQ CARD(TP)) = YES;

  PON(TCH) = PRC(TCH) + CON(TCH);
  ELA(CON) = ELE(CON) + STG(CON) + CPD(CON);
  BASNUC(CON) = BAS(CON) * NUC(CON);
  CENBAS(CON) = CEN(CON) * BAS(CON);
*  CENELE(CON) = CEN(CON) * ELE(CON);
*  DCNELE(CON) = DCN(CON) * ELE(CON);
*GG* V1.1a add CPDs
  CENCPD(CPD) = CEN(CPD) * CPD(CPD);
  DCNCPD(CPD) = DCN(CPD) * CPD(CPD);
  CPDBAS(CPD) = CPD(CPD) * BAS(CPD);
  ELABAS(CON) = ELA(CON) * BAS(CON);
  ELACEN(CON) = CEN(CON) * ELA(CON);
*  ELADCN(CON) = DCN(CON) * ELA(CON);
  ELANUC(CON) = ELA(CON) * NUC(CON);
  ELASTG(CON) = ELA(CON) * STG(CON);
  ELAXBAS(CON) = ELA(CON) - BAS(CON);
  ELAXLM(CON) = ELA(CON) * XLM(CON);
*  ELABASCEN(CON) = ELABAS(CON) * CEN(CON);
*  ELABASDCN(CON) = ELABAS(CON) * DCN(CON);
*  ELAXLMBAS(CON) = ELAXLM(CON) * BAS(CON);
*  ELAXLMCEN(CON) = ELAXLM(CON) * CEN(CON);
*  ELAXLMDCN(CON) = ELAXLM(CON) * DCN(CON);
  ELAXLMSTG(CON) = ELAXLM(CON) * STG(CON);
  NUCXLM(CON) = NUC(CON) * XLM(CON);
*GG* V1.0e heating plants
  HPLXLM(CON) = HPL(CON) * XLM(CON);
*GG* V1.0e find night storage sub-sets
  PRCNST(PRC) = PRC(PRC) * NST(PRC);
  DMDNST(DMD) = DMD(DMD) * NST(DMD);
*GG* V1.0e set the list of imp/exp electricity options
  IMPEXPELC('IMP', P)$SEP('IMP','ELC',P) = YES;
  IMPEXPELC('EXP', P)$SEP('EXP','ELC',P) = YES;
*GG* V1.1a add a class to reset BAS+STG at night
*  BAS_STG(CON, Z, 'N') = BAS(CON) + STG(CON);
*GG* V1.1c add the renewable accounting class
  MAC(ERN)$SUM(P,SEP('RNW',ERN,P)) = YES;
  ERNXMAC(ERN)$(NOT MAC(ERN)) = YES;

*============================================================================*
* Create a second time period class for lead/lag indexing                    *
*============================================================================*
  ALIAS(TP, TC);

*============================================================================*
* Create seasonal totals                                                     *
*============================================================================*
  QHRZ(Z)$(QHR(Z,'D') + QHR(Z,'N')) = QHR(Z,'D') + QHR(Z,'N');

*============================================================================*
*  Set the Start Period to the First Period if None Specified                *
*============================================================================*
  TCH_START(TCH)$(NOT TCH_START(TCH)) = 1;
  SEP_START(SEP)$(NOT SEP_START(SEP)) = 1;
*GG* V1.0i set transmission efficiency by energy carrier if non provided
  TEENC(ENC)$(NOT TEENC(ENC)) = 1;
*GG* V1.1a make a set for the CEN/DCN transmission efficiency
  PARAMETER TE_CON(CON) / EMPTY 0 /;
  TE_CON(CON)$(NOT CEN(CON)) = 1;
  TE_CON(CEN) = TE;

*============================================================================*
*  Set the Lifetime to 1 if none provided but an invest cost is specified    *
*============================================================================*
*GG* V1.0i adjust life
  TCH_LIFE(TCH)$((NOT TCH_LIFE(TCH)) AND SUM(TP, TCH_INVCOS(TCH, TP))) = 1;

*============================================================================*
*  Set the default heat transmission eff. if non provided                    *
*============================================================================*
*GG* V1.1a add CPD
  CPD_TEFF(CPD,Z,Y)$((NOT CPD_TEFF(CPD,Z,Y)) AND QHRZ(Z)) = 1;
  CPD_TEFF(CPD,Z,'N')$BAS(CPD) = 0;

*============================================================================*
*  Expand the Externally Load Managed Processes to Those with 1/no lifetimes *
*============================================================================*
*GG* PRCs with LIFE = 1 are considered dummy processes with only CAP vectors
   YPR(PRC)$(NOT (1$XPR(PRC)) AND
            ((TCH_LIFE(PRC) = 1) OR (NOT (1$TCH_LIFE(PRC)) ))) = YES;
   ZPR(PRC) = XPR(PRC) + YPR(PRC);

*GG* V1.2a have STARTs adjusted if collapsing, *GG* V1.4a remove the paramater
*$BATINCLUDE COLSTART.INC COLLAPSE+1
$BATINCLUDE COLSTART.INC

*============================================================================*
*  To Speed Processing and Reduce Subsequent Testing, Determine the Time     *
*    Periods from Which a Technology/Resource is Available                   *
*============================================================================*
*GG* V1.0e add heating plants
SETS TPTCH, TPDMD, TPPRC, TPCON, TPELA, TPELAXLM, TPZPR, TPHPL, TPCPD;
  TPTCH(TP,TCH)$(ORD(TP) >= TCH_START(TCH)) = YES;
  TPDMD(TP,DMD) = TPTCH(TP,DMD);
  TPPRC(TP,PRC) = TPTCH(TP,PRC);
  TPCON(TP,CON) = TPTCH(TP,CON);
  TPELA(TP,ELA) = TPTCH(TP,ELA);
  TPELAXLM(TP,ELAXLM) = TPTCH(TP,ELAXLM);
  TPZPR(TP,ZPR) = TPTCH(TP,ZPR);
  TPHPL(TP,HPL) = TPTCH(TP,HPL);
*GG* V1.1a add CPD
  TPCPD(TP,CPD) = TPTCH(TP,CPD);

SET TPSEP;
    TPSEP(TP,SEP)$(ORD(TP) >= SEP_START(SEP)) = YES;

*GG* V1.0i add set for Intermediate season exception testing
  ZNOTI('S') =  YES;
  ZNOTI('W') =  YES;
*GG* V1.1a add PEAK TID control set
  SET PEAK_ACT(CON, Z, Y);
  PEAK_ACT(CON, Z, 'N')$PEAK_TID(CON) = YES;
  PEAK_ACT(CON, 'I', 'D')$PEAK_TID(CON) = YES;
  PEAK_ACT(HPL, 'S', 'D')$PEAK_TID(HPL) = YES;
*GG* V1.1a create the complete list of demand devices to demand sectors
*SET DMD_DMS(DMD, DM);
*  DMD_DMS(DMD, DM)$SUM(TP, DMD_OUT(DMD, DM, TP)) = YES;
*  DMD_DMS(DMD, DM) = DMD_DM(DMD, DM) + DMD_DMS(DMD, DM);
*GG* V1.1a add the combined emissions alias
  ALIAS(ENV,GWP);
