*******************************************************************************
*                                                                             *
*  The equations to be included in the MARKAL-MACRO model must be listed in   *
*   this model declaration file.                                              *
*                                                                             *
*******************************************************************************

*=============================================================================*
* Description and type of each equation as declared in MMEQUA.MM              *
*=============================================================================*
$ontext
*  Macro submodel:
  DD(DM,TP)             markal-macro demand coupling equations
  UTIL                  utility equation - objective function for MKMC
  MCAP(TP)              capital - trillion dollars
  TMC(TP)               terminal condition  - trillion dollars
  COSTNRG(TP)           cost of energy - billion dollars
  EQ_IVECBND(TP)        bound on sum of investment and energy costs
  EQ_MPEN(TCH, TP)      market penetration
*GG* V1.0f add substitution equation & variables
  EQ_XCAPDB(TP,TCH)     substitution equation for XCAP
$offtext


MODEL MKMC /
  EQ_PRICE
  EQ_ADRAT1
  EQ_ADRAT2
  EQ_ADRAT3
*GG* V1.1a added OBJ
  EQ_ADRAT4
  EQ_ANNCOST
  EQ_BAL1
  EQ_BAL2
  EQ_BAL3
  EQ_BAL4
  EQ_BAL5
  EQ_BAL6
  EQ_BAL7
  EQ_BALE1
  EQ_BALE2
*GG* V1.0e add heating balance
  EQ_BALDH
  EQ_BAS
*GG* V1.0i bound for conversion technology annual activity
  EQ_BNDCON1
  EQ_BNDCON2
  EQ_BNDCON3
  EQ_CPT1
  EQ_CPT2
  EQ_CPT3
  EQ_CUM
*  EQ_DEM
  EQ_TEZY
*GG* V1.0e add heating balance
  EQ_THZ
  EQ_ENV
  EQ_TENV
  EQ_EPK
*GG* V1.1a add resource and technology incremental growth constraint
  EQ_GRSEP
  EQ_GRTCH
*GG* V1.0e add heating balance
  EQ_HPKW
*GG* V1.1a add the accounting equations
  EQ_FOSSIL
  EQ_TFOSSIL
  EQ_NONRNW
  EQ_TNONRNW
  EQ_NUCLEAR
  EQ_TNUCLAR
  EQ_INVEST
  EQ_PRICER
  EQ_SALVAGE
  EQ_SECURIT
  EQ_TSECURI
*GG* V1.1a add scheduled maintenance for conversion technologies
  EQ_UTLCON
  EQ_UTLPRC
*GG* V1.1a add the variable output limit processes
  EQ_PBL
  EQ_LIM
*GG* V1.4e handle tax/subsidy
  EQ_TXSUB
  DD
*  Macro submodel:
  UTIL
  MCAP
  TMC
  COSTNRG
  EQ_IVECBND
*GG* V1.0f market penetration penalty function
  EQ_XCAPDB
  EQ_MPEN /;

