$OFFLISTING
*******************************************************************************
*   GDP tableand growth rate displays                                         *
*   DISPLAY statements direct output to the *.LST file for the current run.   *
*                                                                             *
*******************************************************************************
*GG* V1.4a added to system to allow printing from MMREPORT.MM and MMINCLUD

*=============================================================================*
*  Calculate Demands Adjusted for AEEI                                        *
*=============================================================================*
*PARAMETERS AD(DM,TP) AEEI * DEMANDS  / EMPTY.EMPTY 0 /;
  AD(TP,DM) = (1/MMSCALE) * AEEIFAC(DM, TP) * D.L(DM, TP);

*=============================================================================*
*  Calculate Gross Domestic Product                                           *
*=============================================================================*
*PARAMETERS GDP(TP)  GROSS DOMESTIC PRODUCT   / EMPTY 0 /;
  GDP(TP) =
        ((AKL * (K.L(TP) ** (KPVS * RHO))) * (L(TP) ** ((1 - KPVS) * RHO)) +
        SUM(DM, B(DM) * D.L(DM, TP) ** RHO)) ** (1 / RHO)
        - EC.L(TP);

*=============================================================================*
*  Calulate Total Consumption                                                 *
*=============================================================================*
*PARAMETERS C(TP)  consumption - trillion dollars / EMPTY 0 /;
  C(TP) = (
    AKL * (K.L(TP) ** (KPVS * RHO)) * L(TP) ** ((1 - KPVS) * RHO) +
    SUM(DM, B(DM) * D.L(DM, TP) ** RHO)
  ) ** (1 / RHO);

*=============================================================================*
*  Set Trigger Flags for Capital, Demand and Investment/Energy Costs          *
*=============================================================================*
*PARAMETERS KBND(TP)     flag for lower bound on capital / EMPTY 0 /;
*PARAMETERS DBND(DM, TP) flag for lower bound on demands / EMPTY.EMPTY 0 /;
*PARAMETERS IEBND(TP)    flag for upper bound on sum of investment and energy costs / EMPTY 0 /;
  KBND(TP)    = K.L(TP)           - K0 * (L(TP) ** 0.5);
  DBND(DM,TP) = D.L(DM,TP)        - D0(DM);
  IEBND(TP)   = Y0 * L(TP) ** 0.5 - IV.L(TP) - EC.L(TP);
* Disregard base year values.
  KBND(TB)    = 1;
  DBND(DM,TB) = 1;
  IEBND(TB)   = 1;
  KBND(TP)    = 1$(KBND(TP) EQ 0);
  DBND(DM,TP) = 1$(DBND(DM, TP) EQ 0);
  IEBND(TP)   = 1$(IEBND(TP) EQ 0);
DISPLAY  KBND, DBND, IEBND;

*=============================================================================*
*  Report Gross Domestic Product, Consumption, Investment and Energy Costs    *
*=============================================================================*
*PARAMETERS VALUEREP(RR, TP) summary report / EMPTY.EMPTY 0 /;
  VALUEREP("GDP"  , TP) = C(TP) - EC.L(TP);
  VALUEREP("CON"  , TP) = C(TP) - IV.L(TP) - EC.L(TP);
  VALUEREP("INV"  , TP) = IV.L(TP);
  VALUEREP("ENC"  , TP) = EC.L(TP);
*GG* V1.0a fix to use # of years
*PARAMETERS GG(RR,TP)        annual growth rates / EMPTY.EMPTY 0 /;
*GG* V1.3b adjust the indexing of the growth rates reported in the *.LST file
*GG* V1.3b adjust so 1990 = 1990-2000 instead of being labelled 2000
*  GG(RR,TP+1) = 100 *((VALUEREP(RR, TP + 1) / VALUEREP(RR, TP))**(1/NYRSPER)-1);
  GG(RR,TP)$(NOT TLAST(TP)) = 100 *((VALUEREP(RR, TP + 1) / VALUEREP(RR, TP))
                                  **(1/NYRSPER)-1);

DISPLAY VALUEREP, GG;
